; Begin
	R0L EQU 0x20
	R0H EQU 0x21
	R1L EQU 0x22
	R1H EQU 0x23
	R2L EQU 0x24
	R2H EQU 0x25
	R3L EQU 0x26
	R3H EQU 0x27
	R4L EQU 0x28
	R4H EQU 0x29
	R5L EQU 0x2A
	R5H EQU 0x2B
	W_TEMP EQU 0x7F
	STATUS_TEMP EQU 0x7E
	ORG 0x0000
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0002
	ORG 0x0004
	MOVWF W_TEMP
	SWAPF STATUS,W
	CLRF STATUS
	MOVWF STATUS_TEMP
	CALL L0003
	SWAPF STATUS_TEMP,W
	MOVWF STATUS
	SWAPF W_TEMP,F
	SWAPF W_TEMP,W
	RETFIE
L0002:
; 1:  'Fejlesztkrnyezet: Picsimulatoride 5.7
; 2:  'RB4 infravev IC be
; 3:  'TMR0 ciklusideje T=1/10000000/4/256=1/9765,625=0,0001024 s
; 4:  'RB7 nullpont figyelse
; 5:  'RA0 Triak gyjt
; 6:  'Ksztette: bbatka
; 7:  '2006.01.10.
; 8:  'Pic16f627   kvarc:10Mhz
; 9: Dim i As Word
;       The address of 'i' is 0x2D
	i EQU 0x2D
; 10: Dim t As Word
;       The address of 't' is 0x2F
	t EQU 0x2F
; 11: Dim d1 As Bit
;       The address of 'd1' is 0x2C,0
; 12: Dim v1 As Word
;       The address of 'v1' is 0x31
	v1 EQU 0x31
; 13: Dim cd As Word
;       The address of 'cd' is 0x33
	cd EQU 0x33
; 14: d1 = 0
	BCF 0x2C,0
; 15: i = 8000 'gyjts helyzett meghatroz vltoz, jelen esetben minimlis fnyerhz lltva
	MOVLW 0x40
	MOVWF 0x2D
	MOVLW 0x1F
	MOVWF 0x2E
; 16: TRISA = %00000000
	BSF STATUS,RP0
	CLRF 0x05
	BCF STATUS,RP0
; 17: TRISB = %10000001
	BSF STATUS,RP0
	MOVLW 0x81
	MOVWF 0x06
	BCF STATUS,RP0
; 18: PORTA = 0
	CLRF 0x05
; 19: OPTION_REG = %11000111 'felhz ellenllsok letiltva, megszakts az RB0 felfut lre, TMR0 bels lptetse,TMR0 oszt 256
	BSF STATUS,RP0
	MOVLW 0xC7
	MOVWF 0x01
	BCF STATUS,RP0
; 20: INTCON.INTE = 1 'engedlyezi RB0/INT megszaktst
	BSF 0x0B,4
; 21: INTCON.RBIE = 1 'engedlyezi a RB4-RB7 megszaktst
	BSF 0x0B,3
; 22: INTCON.GIE = 1 'engedlyez minden nem maszkolt megszaktst
	BSF 0x0B,7
; 23: loop: 
L0001:
; 24: ASM: nop
	nop
; 25: Goto loop
	GOTO L0001
; 26: End
L0004:	GOTO L0004
; 27: 
; 28: On Interrupt 'interrupt routine
L0003:
; 29: If INTCON.INTF = 1 Then
	BTFSS 0x0B,1
	GOTO L0005
; 30: cd = TMR0
	MOVF 0x01,W
	MOVWF 0x33
	CLRF 0x34
; 31: If cd < 15 And cd > 10 Then 'Fnyer nvelse
	MOVF 0x33,W
	MOVWF R0L
	MOVF 0x34,W
	MOVWF R0H
	CLRF R1H
	MOVLW 0x0F
	CALL C004
	BTFSS STATUS,Z
	GOTO L0006
	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x33,W
	MOVWF R0L
	MOVF 0x34,W
	MOVWF R0H
	CLRF R1H
	MOVLW 0x0A
	CALL C003
	BTFSS STATUS,Z
	GOTO L0006
; 32: If i > 2025 Then
	MOVF 0x2D,W
	MOVWF R0L
	MOVF 0x2E,W
	MOVWF R0H
	MOVLW 0x07
	MOVWF R1H
	MOVLW 0xE9
	CALL C003
	BTFSS STATUS,Z
	GOTO L0007
; 33: i = i - 15
	MOVLW 0x0F
	SUBWF 0x2D,W
	MOVWF 0x2D
	MOVLW 0x00
	BTFSS STATUS,C
	ADDLW 0x01
	SUBWF 0x2E,W
	MOVWF 0x2E
; 34: Endif
L0007:	MOVLW 0x1F
	ANDWF STATUS,F
; 35: Endif
L0006:	MOVLW 0x1F
	ANDWF STATUS,F
; 36: If cd > 15 And cd < 19 Then 'Fnyer cskkentse
	MOVF 0x33,W
	MOVWF R0L
	MOVF 0x34,W
	MOVWF R0H
	CLRF R1H
	MOVLW 0x0F
	CALL C003
	BTFSS STATUS,Z
	GOTO L0008
	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x33,W
	MOVWF R0L
	MOVF 0x34,W
	MOVWF R0H
	CLRF R1H
	MOVLW 0x13
	CALL C004
	BTFSS STATUS,Z
	GOTO L0008
; 37: If i < 9000 Then
	MOVF 0x2D,W
	MOVWF R0L
	MOVF 0x2E,W
	MOVWF R0H
	MOVLW 0x23
	MOVWF R1H
	MOVLW 0x28
	CALL C004
	BTFSS STATUS,Z
	GOTO L0009
; 38: i = i + 30
	MOVF 0x2D,W
	ADDLW 0x1E
	MOVWF 0x2D
	MOVF 0x2E,W
	BTFSC STATUS,C
	ADDLW 0x01
	ADDLW 0x00
	MOVWF 0x2E
; 39: Endif
L0009:	MOVLW 0x1F
	ANDWF STATUS,F
; 40: Endif
L0008:	MOVLW 0x1F
	ANDWF STATUS,F
; 41: If cd > 4 And cd < 8 Then 'Be-Kikapcsols
	MOVF 0x33,W
	MOVWF R0L
	MOVF 0x34,W
	MOVWF R0H
	CLRF R1H
	MOVLW 0x04
	CALL C003
	BTFSS STATUS,Z
	GOTO L0010
	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x33,W
	MOVWF R0L
	MOVF 0x34,W
	MOVWF R0H
	CLRF R1H
	MOVLW 0x08
	CALL C004
	BTFSS STATUS,Z
	GOTO L0010
; 42: v1 = v1 + 1
	MOVF 0x31,W
	ADDLW 0x01
	MOVWF 0x31
	MOVF 0x32,W
	BTFSC STATUS,C
	ADDLW 0x01
	ADDLW 0x00
	MOVWF 0x32
; 43: If v1 > 5 Then
	MOVF 0x31,W
	MOVWF R0L
	MOVF 0x32,W
	MOVWF R0H
	CLRF R1H
	MOVLW 0x05
	CALL C003
	BTFSS STATUS,Z
	GOTO L0011
; 44: Toggle d1
	MOVLW 0x01
	XORWF 0x2C,F
; 45: If d1 = 0 Then
	BTFSC 0x2C,0
	GOTO L0012
; 46: i = 2000
	MOVLW 0xD0
	MOVWF 0x2D
	MOVLW 0x07
	MOVWF 0x2E
; 47: v1 = 0
	CLRF 0x31
	CLRF 0x32
; 48: WaitMs 500
	MOVLW 0xF4
	MOVWF R0L
	MOVLW 0x01
	MOVWF R0H
	CALL W001
; 49: Else
	GOTO L0013
L0012:	MOVLW 0x1F
	ANDWF STATUS,F
; 50: i = 8900
	MOVLW 0xC4
	MOVWF 0x2D
	MOVLW 0x22
	MOVWF 0x2E
; 51: v1 = 0
	CLRF 0x31
	CLRF 0x32
; 52: WaitMs 500
	MOVLW 0xF4
	MOVWF R0L
	MOVLW 0x01
	MOVWF R0H
	CALL W001
; 53: Endif
L0013:	MOVLW 0x1F
	ANDWF STATUS,F
; 54: Endif
L0011:	MOVLW 0x1F
	ANDWF STATUS,F
; 55: Endif
L0010:	MOVLW 0x1F
	ANDWF STATUS,F
; 56: TMR0 = 0
	CLRF 0x01
; 57: cd = 0
	CLRF 0x33
	CLRF 0x34
; 58: Endif
L0005:	MOVLW 0x1F
	ANDWF STATUS,F
; 59: If INTCON.RBIF = 1 Then
	BTFSS 0x0B,0
	GOTO L0014
; 60: WaitUs i
	MOVF 0x2D,W
	MOVWF R4L
	MOVF 0x2E,W
	MOVWF R4H
	CALL Y001
; 61: PORTA.0 = 1 '50us gyjt impulzus RA0-ra
	BSF 0x05,0
; 62: WaitUs 50
	MOVLW 0x32
	MOVWF R4L
	CALL X001
; 63: PORTA.0 = 0
	BCF 0x05,0
; 64: WaitUs 10000
	MOVLW 0x10
	MOVWF R4L
	MOVLW 0x27
	MOVWF R4H
	CALL Y001
; 65: PORTA.0 = 1 '50us gyjt impulzus RA0-ra
	BSF 0x05,0
; 66: WaitUs 50
	MOVLW 0x32
	MOVWF R4L
	CALL X001
; 67: PORTA.0 = 0
	BCF 0x05,0
; 68: Endif
L0014:	MOVLW 0x1F
	ANDWF STATUS,F
; 69: INTCON.RBIF = 0 'engedlyezse az j RB7 megszaktsnak
	BCF 0x0B,0
; 70: INTCON.INTF = 0 'engedlyezse az j RB0/INT megszaktsnak
	BCF 0x0B,1
; 71: Resume
	RETURN
; End of program
L0015:	GOTO L0015
; Comparison Routine
C001:	MOVWF R1L
	MOVLW 0x05
	GOTO C007
C002:	MOVWF R1L
	MOVLW 0x02
	GOTO C007
C003:	MOVWF R1L
	MOVLW 0x06
	GOTO C007
C004:	MOVWF R1L
	MOVLW 0x03
	GOTO C007
C005:	MOVWF R1L
	MOVLW 0x04
	GOTO C007
C006:	MOVWF R1L
	MOVLW 0x01
	GOTO C007
C007:	MOVWF R4L
	MOVF R1H,W
	SUBWF R0H,W
	BTFSS STATUS,Z
	GOTO C008
	MOVF R1L,W
	SUBWF R0L,W
C008:	MOVLW 0x04
	BTFSC STATUS,C
	MOVLW 0x01
	BTFSC STATUS,Z
	MOVLW 0x02
	ANDWF R4L,W
	BTFSS STATUS,Z
	MOVLW 0xFF
	RETURN
; Waitms Routine
W001:	MOVF R0L,F
	BTFSC STATUS,Z
	GOTO W002
	CALL W003
	DECF R0L,F
	NOP
	NOP
	NOP
	NOP
	NOP
	GOTO W001
W002:	MOVF R0H,F
	BTFSC STATUS,Z
	RETURN
	CALL W003
	DECF R0H,F
	DECF R0L,F
	GOTO W001
W003:	MOVLW 0x0C
	MOVWF R2H
W004:	DECFSZ R2H,F
	GOTO W004
	NOP
	NOP
	MOVLW 0x30
	MOVWF R1L
W005:	DECFSZ R1L,F
	GOTO W006
	CALL W007
	CALL W007
	NOP
	NOP
	RETURN
W006:	CALL W007
	GOTO W005
W007:	MOVLW 0x0D
	MOVWF R2L
W008:	DECFSZ R2L,F
	GOTO W008
	NOP
	RETURN
; Waitus Routine - Byte Argument
X001:	MOVLW 0x04
	SUBWF R4L,F
	BTFSS STATUS,C
	RETURN
	GOTO X002
X002:	MOVLW 0x04
	SUBWF R4L,F
	NOP
	NOP
	NOP
	NOP
	BTFSS STATUS,C
	RETURN
	GOTO X002
; Waitus Routine - Word Argument
Y001:	MOVLW 0x07
	SUBWF R4L,F
	CLRW
	BTFSS STATUS,C
	ADDLW 0x01
	SUBWF R4H,F
	BTFSS STATUS,C
	RETURN
	GOTO Y002
Y002:	MOVLW 0x04
	SUBWF R4L,F
	CLRW
	BTFSS STATUS,C
	ADDLW 0x01
	SUBWF R4H,F
	BTFSS STATUS,C
	RETURN
	GOTO Y002
; End of listing
	END
